=== level_zero/api/runtime/CMakeLists.txt ===
#
# Copyright (C) 2025 Intel Corporation
#
# SPDX-License-Identifier: MIT
#

target_sources(${L0_STATIC_LIB_NAME}
               PRIVATE
               ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
               ${CMAKE_CURRENT_SOURCE_DIR}/ze_runtime_all_api_entrypoints.h
               ${CMAKE_CURRENT_SOURCE_DIR}/ze_runtime_loader.cpp
)
