=== debian/changelog ===
intel-compute-runtime (25.48.36300.8-1) unstable; urgency=medium

  [ Pavel Androniychuk ]
  * New upstream release
  * control: bump build-dep for igc and libze-dev
  * alternatives: update version for ocloc
  * symbols: updated

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Feb 2026 14:53:03 +0200
